// ShellSort.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream.h>
#include <stdlib.h>
#include <time.h>

void TiskPole(int *pPole, unsigned int dwVel)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			cout << pPole[i] << " ";
		}

		cout << endl << endl;
	}
}

void NaplnPole(int *pPole, unsigned int dwVel)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			pPole[i] = rand() % 20;
		}
	}
}



void ShellSort(int *pPole, unsigned int dwVel)
{
	unsigned int i, j, k;
	int iPomocna;			// vymeny prvku
    unsigned int krok[3];	// pole velikosti kroku
  
	// nastaveni velikosti kroku
	krok[0] = 4;
	krok[1] = 2;
	krok[2] = 1;
  
	for(unsigned int m = 0; m < 3; m++)
	{
		k = krok[m];	// zkopirujeme si velikost kroku se kterym prave pracujeme
		
		// provedeme trideni primym vkladanim
		for(i = k; i < dwVel; i++)
		{
			iPomocna = pPole[i];
			j = i;
		
			while((j >= k) && (iPomocna < pPole[j-k]))
			{
				pPole[j] = pPole[j - k];
				j -= k;
			}
     
			pPole[j] = iPomocna;
		}
	}
}

int Pole[20];

int main(int argc, char* argv[])
{
	srand((unsigned)time(NULL));	// abychom dostali pri kazdem spusteni jina cisla
	
	for(int i = 0; i < 3; i++)
	{
		cout << "Nesetrideno: " << endl;
		NaplnPole(Pole, 20);
		TiskPole(Pole, 20);
		ShellSort(Pole, 20);
		cout << "Setrideno: " << endl;
		TiskPole(Pole, 20);
		
	}

	char c;
	cin >> c;
	return 0;
}