// Countingsort.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream.h>
#include <stdlib.h>
#include <time.h>
#include <memory.h>

void TiskPole(int *pPole, unsigned int dwVel)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			cout << pPole[i] << " ";
		}

		cout << endl << endl;
	}
}

void NaplnPole(int *pPole, unsigned int dwVel)
{
	if(pPole)
	{
		for(unsigned int i = 0; i < dwVel; i++)
		{
			pPole[i] = rand() % 20;
		}
	}
}



void CountingSort(int *pPole, unsigned int dwVel, int iMaxPrvek)
{
	int *pC = new int[iMaxPrvek];	// pole pC obsahuje, kolikrat se vyskytuje cislo v poli
	int *pB = new int[dwVel + 1];

	// vynulujeme pole cetnosti
	for(int i = 0; i < iMaxPrvek; i++)
	{
		pC[i] = 0;
	}
	
	// projdeme postupne pole a spocteme vyskyt jednotlivych cisel
	for(unsigned int j = 0; j < dwVel; j++)
	{
		pC[pPole[j]]++;	// indexujeme primo cisly, ktera tridime
	}
	
	// provedeme secteni i-teho a predchazejiciho prvku v poli pC - pole pC bude obsahovat indexy prvku
	for(i = 1; i < iMaxPrvek; i++)
	{
		pC[i] += pC[i-1];
	}
	
	// tridene pole projdeme odzadu a budeme radit prvky podle indexu v poli pC
	for(i = dwVel-1; i >= 0; i--)
	{
		pB[pC[pPole[i]]] = pPole[i];
		pC[pPole[i]]--;
	}
	// v poli pB je vysledek, ktery prekopirujeme do puvodniho pole
	for(j = 0; j < dwVel; j++)
	{
		pPole[j] = pB[j + 1];
	}
	// smazeme pomocna pole
	delete [] pC;
	delete [] pB;
}

int Pole[20];

int main(int argc, char* argv[])
{
	srand((unsigned)time(NULL));	// abychom dostali pri kazdem spusteni jina cisla
	
	for(int i = 0; i < 3; i++)
	{
		cout << "Nesetrideno: " << endl;
		NaplnPole(Pole, 20);
		TiskPole(Pole, 20);
		CountingSort(Pole, 20, 20);
		cout << "Setrideno: " << endl;
		TiskPole(Pole, 20);
		
	}

	char c;
	cin >> c;
	return 0;
}